// Copyright (C) 2005 Shai Ayal <shaiay@users.sourceforge.net>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//  

#ifndef MATHUTILS_H
#define MATHUTILS_H

#include <cmath>
#include <vector>
#include "prop_matrix.h"

void FindMinMax(Matrix& M,
		double& min,
		double& max,
		double& lmin,
		double& lmax,
		long length=0);

void InterpColor(Matrix& Colormap, Matrix& Clim, double z, double cv[4]);

vector<unsigned int>* FactorList(unsigned int n);

#endif
